<div class="wrap omnivo_calendar_settings_section first">
	<h2><?php _e("Google Calendar", "omnivo_calendar"); ?></h2>
</div>
	<div id="omnivo_calendar_configuration_tabs" class="omnivo_calendar_hide">
		<ul class="nav-tabs">
			<li class="nav-tab">
				<a href="#tab-configuration">
					<?php _e('Configuration', 'omnivo_calendar'); ?>
				</a>
			</li>
			<li class="nav-tab">
				<a href="#tab-export">
					<?php _e('Export', 'omnivo_calendar'); ?>
				</a>
			</li>
			<li class="nav-tab">
				<a href="#tab-import">
					<?php _e('Import', 'omnivo_calendar'); ?>
				</a>
			</li>
		</ul>
		<div id="tab-configuration">
			<form action="<?php echo $_SERVER['REQUEST_URI']; ?>" method="post" class="google_calendar">
				<input type="hidden" name="action" value="save" />
				<table class="omnivo_calendar_table form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">
								<label for="calendar_id">
									<?php _e("Calendar ID", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<input type="text" class="regular-text" value="<?php echo esc_attr($googleCalendar->id); ?>" id="calendar_id" name="calendar_id">
							</td>
							<td>
								<span class="description"><?php _e("Google Calendar ID.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top" class="no-border">
							<th scope="row">
								<label for="service_account_encoded">
									<?php _e("Service account", "omnivo_calendar"); ?>
								</label>
							</th>
							<td colspan="2">
								<span class="description long"><?php _e("Copy/paste the contents of downloaded *.json file.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<td colspan="3">
								<textarea id="service_account_encoded" name="service_account_encoded" class="regular-text" style="width: 770px; height: 200px;"><?php echo esc_html($googleCalendar->service_account_encoded); ?></textarea>
							</td>
						</tr>
						<tr valign="top" >
							<th colspan="3">
								<input type="submit" value="<?php esc_attr_e("Save Options", "omnivo_calendar") ?>" class="button-primary" name="Submit">
							</th>
						</tr>
					</tbody>
				</table>
			</form>
			<table class="omnivo_calendar_table form-table">
				<tbody>
					<tr valign="top" class="no-border">
						<td colspan="3">
							<h3><?php _e("Integration instructions", "omnivo_calendar"); ?></h3>
							<p><?php _e("1. Log in to your Gmail account.", "omnivo_calendar"); ?></p>
							<p><?php echo sprintf(__("2. Visit <a href='%s' target='_blank'>Google API Console</a> page and create a new project . In 'Project name' field specify the name and click 'Create' .", "omnivo_calendar"), "https://console.developers.google.com/"); ?></p>
							<p><?php echo __("3. In 'Navigation Menu' select 'IAM & admin->Service accounts', now click on '+ Create Service Account' option. Specify the account name and click 'Create'. In next step set Role to 'Project->Editor' and click 'Continue'. In 3rd step select '+ Create Key' button, set 'Key type' to 'JSON' and click 'Create' button, download the .json file generated by Google.", "omnivo_calendar"); ?></p>
							<p><?php echo __("4. Now go to API library , search for 'Calendar' and select 'Google Calendar API' result. Click on 'Enable' button, this way the API will be enabled for your project .", "omnivo_calendar"); ?></p>
							<p><?php echo sprintf(__("5. Visit <a href='%s' target='_blank'>Google Calendar</a> and add new calendar . Go to 'Calendar settings' panel and in 'Share with specific people' section add the service account email created in point 4. Permissions options must be set to 'Make changes to events'. If you don't remember your service account email then please visit <a href='%s' target='_blank'>Google API Console</a> and select the calendar project that you've created earlier. Now from 'IAM & admin' menu select the 'Service accounts' option . Now just look for 'Email' column in service accounts list . In 'Calendar settings' please check 'Integrate Calendar' section copy the 'Calendar ID' value .", "omnivo_calendar"), "https://calendar.google.com/", "https://console.developers.google.com/"); ?></p>
							<p><?php echo __("6. Now visit 'Omnivo Calendar->Google Calendar' panel and open 'Configuration' tab. In 'Calendar ID' field you must specify the ID from previous step and in 'Service account' textarea insert the contents of .json file downloaded in step 4 .", "omnivo_calendar"); ?></p>
							<p><?php _e("7. In 'Settings->General' panel please make sure that 'Timezone' option has the same value as in your Google Calendar.", "omnivo_calendar"); ?></p>
						</td>
					</tr>
				</tbody>
			</table>
		</div>
		<div id="tab-export">
			<form action="<?php echo $_SERVER['REQUEST_URI']; ?>#tab-export" method="post" class="google_calendar">
				<input type="hidden" name="action" value="export" />
				<table class="form-table omnivo_calendar_table">
					<tbody>
						<tr valign="top">
							<th scope="row">
								<label for="events-export">
									<?php _e("Events", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select id="events-export" name="event[]" multiple="multiple">
									<?php
									if($Events)
									{
										foreach($Events as $Event)
										{
											echo '<option value="' . urldecode($Event->post_name) . '">' . $Event->post_title . ' (id: ' . $Event->ID . ')' . '</option>';
										}
									}
									?>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Select the events that should be exported. Hold the CTRL key to select multiple items.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="monday-export">
									<?php _e("Monday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="monday-export">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==1 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Monday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="tuesday-export">
									<?php _e("Tuesday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="tuesday-export">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==2 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Tuesday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="wednesday-export">
									<?php _e("Wednesday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="wednesday-export">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==3 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Wednesday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="thursday-export">
									<?php _e("Thursday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="thursday-export">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==4 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Thursday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="friday-export">
									<?php _e("Friday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="friday-export">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==5 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Friday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="saturday-export">
									<?php _e("Saturday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="saturday-export">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==6 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Saturday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="sunday-export">
									<?php _e("Sunday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="sunday-export">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==7 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Sunday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th colspan="2">
								<input type="submit" value="<?php esc_attr_e("Export", "omnivo_calendar") ?>" class="button-primary" name="Export">
							</th>
							<td>
								<span class="description"><?php _e("Export selected events to Google Calendar.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
					</tbody>
				</table>
			</form>
			<table class="omnivo_calendar_table form-table">
				<tbody>
					<tr valign="top" class="no-border">
						<td colspan="3">
								<h3><?php _e("Export instructions", "omnivo_calendar"); ?></h3>
								<p><?php _e("This panel allows you to export event hours into Google Calendar. You can specify which events should be used and you can also assign columns to weekdays.", "omnivo_calendar"); ?></p>
								<p><?php _e("When you click 'Export' button then the plugin will create mentioned events in the Calendar. If you make changes to the exported event hours then you can once again use export feature to update event details in Google Calendar.", "omnivo_calendar"); ?></p>
							</td>
					</tr>
				</tbody>
			</table>
		</div>
		<div id="tab-import">
			<form action="<?php echo $_SERVER['REQUEST_URI']; ?>#tab-import" method="post" class="google_calendar">
				<input type="hidden" name="action" value="get_calendar_data" />
				<table class="omnivo_calendar_table form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">
								<label for="get_calendar_data">
									<?php _e("Google Calendar", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<?php
								$label_calendar_data = '';
								if($UniqueCalendarEvents)
									$label_calendar_data = __("Refresh Calendar data", "omnivo_calendar");
								else
									$label_calendar_data = __("Get Calendar data", "omnivo_calendar");
								?>
								<input id="get_calendar_data" type="submit" value="<?php echo esc_attr($label_calendar_data) ?>" class="button-primary regular-text" name="Import">
							</td>
							<td>
								<span class="description"><?php _e("Fetches events data from Google Calendar.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
					</tbody>
				</table>
			</form>
			<?php
			if($UniqueCalendarEvents)
			{
			?>
			<form action="<?php echo $_SERVER['REQUEST_URI']; ?>#tab-import" method="post" class="google_calendar">
				<input type="hidden" name="action" value="import" />
				<table class="omnivo_calendar_table form-table">
					<tbody>
						<tr valign="top">
							<th scope="row">
								<label for="calendar_event">
									<?php _e("Calendar Events", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="calendar_event[]" id="calendar_event" multiple="multiple">
									<?php
									foreach($UniqueCalendarEvents as $UniqueCalendarEvent)
									{
										echo '<option value="' . esc_attr($UniqueCalendarEvent) . '" >' . esc_html($UniqueCalendarEvent) . '</option>';
									}
									?>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Select the events that should be imported. Hold the CTRL key to select multiple items.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="monday-import">
									<?php _e("Monday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="monday-import">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==1 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Monday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="tuesday-import">
									<?php _e("Tuesday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="tuesday-import">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==2 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Tuesday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="wednesday-import">
									<?php _e("Wednesday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="wednesday-import">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==3 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Wednesday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="thursday-import">
									<?php _e("Thursday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="thursday-import">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==4 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Thursday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="friday-import">
									<?php _e("Friday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="friday-import">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==5 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Friday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="saturday-import">
									<?php _e("Saturday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="saturday-import">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==6 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Saturday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th scope="row">
								<label for="sunday-import">
									<?php _e("Sunday", "omnivo_calendar"); ?>
								</label>
							</th>
							<td>
								<select name="weekday[]" id="sunday-import">
									<?php
									if($Weekdays)
									{
										foreach($Weekdays as $Weekday)
										{
											echo '<option value="' . urldecode($Weekday->post_name) . '"  ' . ($Weekday->menu_order==7 ? 'selected' : '') . '>' . $Weekday->post_title . ' (id: ' . $Weekday->ID . ')' . '</option>';
										}
									}
									?>
									<option value=""><?php _e("None", "omnivo_calendar"); ?></option>
								</select>
							</td>
							<td>
								<span class="description"><?php _e("Assign column to Sunday.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
						<tr valign="top">
							<th colspan="2">
								<input type="submit" value="<?php esc_attr_e("Import", "omnivo_calendar") ?>" class="button-primary" name="Import">
							</th>
							<td>
								<span class="description"><?php _e("Import events from Google Calendar.", "omnivo_calendar"); ?></span>
							</td>
						</tr>
					</tbody>
				</table>
			</form>
			<?php
			}
			?>
			<table class="omnivo_calendar_table form-table">
				<tbody>
					<tr valign="top" class="no-border">
						<td colspan="3">
							<h3><?php _e("Import instructions", "omnivo_calendar"); ?></h3>
							<p><?php _e("Panel allows you to import events from your calendar to the Calendar plugin. Before you import events you have to fetch calendar data, after that you will see a list of available events that you can import into calendar. Simillary to Export feature you can assign your columns to the weekdays.", "omnivo_calendar"); ?></p>
							<p><?php _e("If you made changes to the calendar events, then you can once again perform an import. This way the event hours in Calendar will be updated with new data.", "omnivo_calendar"); ?></p>
						</td>
					</tr>
				</tbody>
			</table>
		</div>
	</div>

